'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

//------------------------------------------------------------------------------
// Rule Definition
//------------------------------------------------------------------------------

module.exports = {
  meta: {
    docs: {},

    schema: [{
      type: 'object',
      properties: {
        'max-params': {
          type: 'integer',
          minimum: 0
        }
      },
      additionalProperties: false
    }]
  },

  create: function inParams(context) {
    var option = context.options[0];
    var maxParams = 1;

    if ((typeof option === 'undefined' ? 'undefined' : _typeof(option)) === 'object' && option.hasOwnProperty('max-params') && typeof option['max-params'] === 'number') {
      maxParams = option['max-params'];
    }

    return {
      ObjectPattern: function ObjectPattern(node) {
        if (node.parent.type === 'ArrowFunctionExpression' || node.parent.type === 'FunctionDeclaration') {
          if (node.parent.params.length > maxParams) {
            context.report(node, 'Do not use destructuring in params when there' + (' are more than ' + maxParams + ' params.'));
          }
        }
      }
    };
  }
};